# EzCAD Patcher

This tool parses and patches EZCAD files with values specified in a YAML config file.

## Usage

``` text
Usage: ezcad_patcher.exe [OPTIONS] --input <INPUT>

Options:
  -i, --input <INPUT>    Input file to parse
  -o, --output <OUTPUT>  Output file to write to
  -c, --config <CONFIG>  Configuration file
  -v, --verbose...       Increase logging verbosity
  -q, --quiet...         Decrease logging verbosity
  -h, --help             Print help
```

## Patching Pen Settings

Three operations are supported for patching pen settings:

1. Setting values of specific fields for a given pen:

``` yaml
Ops: 
  - !PatchPen
    Pen: 0                  # Required - target pen
    Color: [127, 127, 127]  # Optional - target pen RGB color
    Enabled: true           # Optional - target pen enable flag
    LoopCount: 3            # Optional - target pen loop count
    Speed: 1.234            # Optional - target pen speed
    Power: 10.5             # Optional - target pen power 
    Frequency: 10000        # Optional - target pen frequency
```

2. Cloning one pen to another (and optionally override settings):

``` yaml
Ops: 
  - !ClonePen
    From: 0                 # Required - source pen
    To: 1                   # Required - target pen
    # Color: [64, 64, 64]   # Optional - target pen RGB color
    # Enabled: true         # Optional - target pen enable flag
    # LoopCount: 3          # Optional - target pen loop count
    # Speed: 1.234          # Optional - target pen speed
    # Power: 10.5           # Optional - target pen power 
    # Frequency: 10000      # Optional - target pen frequency
```

3. Incrementing a specific field by some value across a sequence of pens:

``` yaml
Ops: 
  - !PatternPen
    From: 1                 # Required - starting pen to copy settings from
    To: 5                   # Required - ending pen to stop at (inclusive)
    # Field: !Loops 1         # Choose one
    # Field: !Speed 100.0     # Choose one
    # Field: !Power 10.0      # Choose one
    # Field: !Frequency 1000  # Choose one
```

Patching operations will be applied in the order that they are defined.
