use binrw::{BinRead, BinWrite};
use diff::Diff;

use crate::{array_of::ArrayOf, types::Point};

use super::ObjectCore;

#[derive(BinRead, BinWrite, Debug, Diff, PartialEq)]
#[diff(attr(
    #[derive(Debug, PartialEq)]
))]
pub enum LineType {
    #[brw(magic = 0x0001u16)]
    Point { _zero: u32, point: Point },
    #[brw(magic = 0x0100u16)]
    Line { _zero: u32, points: ArrayOf<Point> },
    #[brw(magic = 0x0300u16)]
    Bezier { _zero: u32, points: ArrayOf<Point> },
}

#[derive(BinRead, BinWrite, Debug, Diff, PartialEq)]
#[diff(attr(
    #[derive(Debug, PartialEq)]
))]
pub struct Lines {
    pub core: ObjectCore,
    pub lines: ArrayOf<LineType, u64>,
}
